# -*-python-*-

__package__    = "modestMMarkers/feeds/__init__.py"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/modestMMarkers"
__date__       = "$Date: 2009/04/24 16:08:49 $"
__copyright__  = "Copyright (c) 2009 Aaron Straup Cope. BSD license : http://www.modestmaps.com/license.txt"

import urllib2
from htmlentitydefs import name2codepoint as n2cp
import re
import textwrap

from modestMMarkers import utils

class mmProvider () :

    def __init__ (self, *args) :

        self.feed_url = None
        self.feed_type = None
        self.feed_title = None

        self.show_urls = False
        self.www_url = None

    #############################################################
    
    def draw_feed (self, url, **kwargs) :

        zoom = 15

        if kwargs.has_key('zoom') :
            zoom = int(kwargs['zoom'])
            
        xml = self.fetch_url(url)

        feed = self.parse_feed(xml)

        bbox = self.calculate_bbox(feed['points'])
        
        self.add_markers(feed['items'].values())
        self.draw(bbox, zoom)

    #############################################################        
    
    def fetch_url (self, url) :

        self.feed_url = url
        
        try :
            fh = urllib2.urlopen(url)
            return fh.read()
        except Exception, e :
            print e
            return None

    #############################################################
    
    def calculate_bbox (self, points) :

        bbox = utils.calculate_bbox_for_points(points)
        bbox = utils.expand_bbox(bbox, .1)
        return bbox

    #############################################################
    
    def substitute_entity (self, match):
        ent = match.group(2)
        if match.group(1) == "#":
            return unichr(int(ent))
        else:
            cp = n2cp.get(ent)

            if cp:
                return unichr(cp)
            else:
                return match.group()

    #############################################################

    def decode_htmlentities (self, string) :
        entity_re = re.compile("&(#?)(\d{1,5}|\w{1,8});")
        return entity_re.subn(self.substitute_entity, string)[0]
    
    #############################################################

    def clean_description (self, desc, wrap=50) :
        desc = self.decode_htmlentities(desc)
        desc = re.sub(r'<br>', '\n', desc)
        desc = re.sub(r'<[^>]*?>', '', desc)

        desc = textwrap.dedent(desc)
        desc = textwrap.wrap(desc, wrap)
        return "\n".join(desc)
        
    #############################################################    

