__package__    = "modestMMarkers/feeds/mmAtom/__init__.py"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/modestMMarkers"
__date__       = "$Date: 2009/04/24 16:08:49 $"
__copyright__  = "Copyright (c) 2009 Aaron Straup Cope. BSD license : http://www.modestmaps.com/license.txt"

from  modestMMarkers.feeds import mmProvider
import re

class mmAtom (mmProvider) :

    def __init__ (self, *args) :
        mmProvider.__init__(self, *args)
        self.feed_type = "atom"

    #############################################################
        
    def parse_feed (self, data) :

        feed = {
            'title':None,
            'points':[],
            'items':{},
            'lookup':{},
            }
        
        import elementtree.ElementTree as ET
        tree = ET.fromstring(data)

        atom = 'http://www.w3.org/2005/Atom'

        points = []
        markers = []

        feed['title'] = tree.findtext("{%s}title" % (atom))
        
        for entry in tree.findall(".//{%s}entry" % atom) : 

            pt = self.find_latlon(entry)

            if not pt :
                continue

            # A dopplr-ism
            title = entry.findtext("{%s}title" % atom).split(" by ")[0]
            author = entry.findtext("{%s}author/{%s}name" % (atom, atom))

            uid = entry.findtext("{%s}id" % (atom))
            
            tags = [author]
            
            for c in entry.findall("{%s}category" % atom) :
                tags.append(c.attrib['term'])

            desc = entry.findtext("{%s}content" % atom)
            desc = self.clean_description(desc)
            
            item = {
                'label':title,
                'title':title,
                'latitude':pt[0],
                'longitude':pt[1],
                'tags':tags,
                'description':desc}
            
            feed['items'][uid] = item

            # lookup tables

            coord = "%s,%s" % (pt[0], pt[1])

            feed['lookup'][coord] = uid
            feed['points'].append(pt)
            
        return feed

    #############################################################
    
    def find_latlon (self, entry) :

        gml = 'http://www.opengis.net/gml'
        atom = 'http://www.w3.org/2005/Atom'
        
        geo = entry.findtext(".//{%s}pos" % gml)
        
        if geo :
            pt = map(lambda x: float(x), geo.strip().split(" "))
            return (pt[0], pt[1])

        return None

    #############################################################
