__package__    = "modestMMarkers/polylines/__init__.py"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/modestMMarkers"
__date__       = "$Date: 2009/04/24 16:08:49 $"
__copyright__  = "Copyright (c) 2009 Aaron Straup Cope. BSD license : http://www.modestmaps.com/license.txt"

from modestMMarkers import utils
import cairo

class polyline :

    def __init__ (self, mm_obj) :
        self.mm_obj = mm_obj

    # #########################################################

    def draw_points (self, mm_img, points, **kwargs):

        if kwargs.has_key('colour') :
            r = kwargs['colour'][0]
            g = kwargs['colour'][1]
            b = kwargs['colour'][2]
        else :
            r = 255
            g = 0
            b = 132

        cairo_surface = utils.pil2cairo(mm_img)

        for c in points :

            pt = utils.latlon_to_point(self.mm_obj, c['latitude'], c['longitude'])
            x = pt.x
            y = pt.y
            
            ctx = cairo.Context(cairo_surface)        
            ctx.move_to(x, y)
            ctx.arc(x, y, 10, 0, 360)
            ctx.set_source_rgba(r, g, b, .4)
            #ctx.stroke()
            ctx.fill()

        return utils.cairo2pil(cairo_surface)

    # #########################################################

    # PLEASE WRITE ME...
    
    def draw_boundingbox (self) :
        pass
    
    # #########################################################
    
    def draw_polylines (self, mm_img, polylines, **kwargs) :

        if kwargs.has_key('colour') :
            r = kwargs['colour'][0]
            g = kwargs['colour'][1]
            b = kwargs['colour'][2]
        else :
            r = 255
            g = 0
            b = 132

        if kwargs.has_key('opacity_fill') :
            O = kwargs['opacity_fill']
        else :
            O = 0.4

        if kwargs.has_key('opacity_border') :
            B = kwargs['opacity_border']
        else :
            B = 1
            
        cairo_surface = utils.pil2cairo(mm_img)
                
        for coords in polylines :
            points = []

            for c in coords :

                pt = utils.latlon_to_point(self.mm_obj, c['latitude'], c['longitude'])
                points.append(pt)

            if not kwargs.has_key('no_fill') :
                ctx = self.draw_polyline_points(cairo_surface, points)
                ctx.set_source_rgba(r, g, b, O)	# that's an 'oh'
                ctx.fill()

            ctx = self.draw_polyline_points(cairo_surface, points)
            ctx.set_source_rgba(r, g, b, B)
            ctx.set_line_width(2)        
            ctx.stroke()
            
        return utils.cairo2pil(cairo_surface)
        
    # #########################################################
    
    def draw_polyline (self, mm_img, coords, colour=(255, 0, 132)) :
        return self.draw_polylines(mm_img, [coords], colour)

    # #########################################################
    
    def draw_polyline_points (self, surface, points) :
        
        first = points[0]
        x = int(first.x)
        y = int(first.y)

        ctx = cairo.Context(surface)
        ctx.move_to(int(first.x), int(first.y))
        
        for pt in points :
            x = int(pt.x)
            y = int(pt.y)
            ctx.line_to(x, y)

        ctx.close_path()
        return ctx

    # #########################################################
