__package__    = "modestMMarkers/modestMMarkers/primitives/__init__.py"
__version__    = "0.1"
__author__     = "Aaron Straup Cope"
__url__        = "http://www.aaronland.info/python/modestMMarkers"
__date__       = "$Date: 2009/04/25 21:22:12 $"
__copyright__  = "Copyright (c) 2007-2008 Aaron Straup Cope. BSD license : http://www.modestmaps.com/license.txt"

import cairo

from modestMMarkers import text

def draw_circle_with_string (surface, args) :

    bg_c = (255, 255, 255)
    str_c = (0, 0, 0)
    txt_c = (0, 0, 0)
        
    if args.has_key('background_c'):
        bg_c = args['background_c']

    if args.has_key('stroke_c'):
        str_c = args['stroke_c']

    if args.has_key('text_c'):
        txt_c = args['text_c']

    x = args['x']
    y = args['y']
    r = args['radius']
    a = 0

    if args.has_key('anchor_height') :
        a  = args['anchor_height']

    if a != 0 :
        y = y - (a + int(args['radius'] / 2))
        
    #
        
    if a != 0 :
        ctx = cairo.Context(surface)        
        ctx.move_to(args['x'], args['y'])
        ctx.set_source_rgb(str_c[0], str_c[1], str_c[2])            
        ctx.set_line_width(2)
        ctx.line_to(args['x'], (args['y'] - a))
        ctx.stroke()

    ctx = cairo.Context(surface)        
    ctx.move_to(x, y)
    ctx.arc(x, y, r, 0, 360)
    ctx.set_source_rgb(bg_c[0], bg_c[1], bg_c[2])
    ctx.fill()
        
    ctx = cairo.Context(surface)
    ctx.arc(x, y, r, 0, 360)        
    ctx.set_source_rgb(str_c[0], str_c[1], str_c[2])
    ctx.set_line_width(2)
    ctx.stroke()
    
    ctx = cairo.Context(surface)                                
    ctx.set_source_rgb(txt_c[0], txt_c[1], txt_c[2])    
    
    offset_x, offset_y = text.offsets_for_page_number(ctx, args['string'])
    
    x = x + offset_x
    y = y - offset_y

    text.assign_font_details(ctx, font_face='Helvetica Bold')

    ctx.move_to(x, y)
    ctx.show_text(unicode(args['string']))
    
